type token =
    ANNOT of (int * string)
  | IDENTIFIER of (string)
  | CONSTANT of (string)
  | STRING_LITERAL of (string)
  | TYPE_NAME of (string)
  | SIZEOF
  | PTR_OP
  | INC_OP
  | DEC_OP
  | LEFT_OP
  | RIGHT_OP
  | LE_OP
  | GE_OP
  | EQ_OP
  | NE_OP
  | AND_OP
  | OR_OP
  | MUL_ASSIGN
  | DIV_ASSIGN
  | MOD_ASSIGN
  | ADD_ASSIGN
  | SUB_ASSIGN
  | LEFT_ASSIGN
  | RIGHT_ASSIGN
  | AND_ASSIGN
  | XOR_ASSIGN
  | OR_ASSIGN
  | TYPEDEF
  | EXTERN
  | STATIC
  | AUTO
  | REGISTER
  | CHAR
  | SHORT
  | INT
  | LONG
  | SIGNED
  | UNSIGNED
  | FLOAT
  | DOUBLE
  | CONST
  | VOLATILE
  | VOID
  | STRUCT
  | UNION
  | ENUM
  | ELLIPSIS
  | CASE
  | DEFAULT
  | IF
  | ELSE
  | SWITCH
  | WHILE
  | DO
  | FOR
  | GOTO
  | CONTINUE
  | BREAK
  | RETURN
  | SEMICOLON
  | LBRACE
  | RBRACE
  | COMMA
  | COLON
  | EQUAL
  | LPAR
  | RPAR
  | LSQUARE
  | RSQUARE
  | DOT
  | AMP
  | EXL
  | TILDE
  | MINUS
  | PLUS
  | STAR
  | SLASH
  | PERCENT
  | LT
  | GT
  | HAT
  | PIPE
  | QUESTION
  | EOF

open Parsing
# 20 "src/cparser.mly"

  open Logic
  open Ptree
  open Cast
  open Parsing

  let loc () = (symbol_start (), symbol_end ())

  let uns () =
    raise (Stdpp.Exc_located (loc (), Stream.Error "Unsupported C syntax"))

(* Line 15, file src/cparser.ml *)
let yytransl_const = [|
  262 (* SIZEOF *);
  263 (* PTR_OP *);
  264 (* INC_OP *);
  265 (* DEC_OP *);
  266 (* LEFT_OP *);
  267 (* RIGHT_OP *);
  268 (* LE_OP *);
  269 (* GE_OP *);
  270 (* EQ_OP *);
  271 (* NE_OP *);
  272 (* AND_OP *);
  273 (* OR_OP *);
  274 (* MUL_ASSIGN *);
  275 (* DIV_ASSIGN *);
  276 (* MOD_ASSIGN *);
  277 (* ADD_ASSIGN *);
  278 (* SUB_ASSIGN *);
  279 (* LEFT_ASSIGN *);
  280 (* RIGHT_ASSIGN *);
  281 (* AND_ASSIGN *);
  282 (* XOR_ASSIGN *);
  283 (* OR_ASSIGN *);
  284 (* TYPEDEF *);
  285 (* EXTERN *);
  286 (* STATIC *);
  287 (* AUTO *);
  288 (* REGISTER *);
  289 (* CHAR *);
  290 (* SHORT *);
  291 (* INT *);
  292 (* LONG *);
  293 (* SIGNED *);
  294 (* UNSIGNED *);
  295 (* FLOAT *);
  296 (* DOUBLE *);
  297 (* CONST *);
  298 (* VOLATILE *);
  299 (* VOID *);
  300 (* STRUCT *);
  301 (* UNION *);
  302 (* ENUM *);
  303 (* ELLIPSIS *);
  304 (* CASE *);
  305 (* DEFAULT *);
  306 (* IF *);
  307 (* ELSE *);
  308 (* SWITCH *);
  309 (* WHILE *);
  310 (* DO *);
  311 (* FOR *);
  312 (* GOTO *);
  313 (* CONTINUE *);
  314 (* BREAK *);
  315 (* RETURN *);
  316 (* SEMICOLON *);
  317 (* LBRACE *);
  318 (* RBRACE *);
  319 (* COMMA *);
  320 (* COLON *);
  321 (* EQUAL *);
  322 (* LPAR *);
  323 (* RPAR *);
  324 (* LSQUARE *);
  325 (* RSQUARE *);
  326 (* DOT *);
  327 (* AMP *);
  328 (* EXL *);
  329 (* TILDE *);
  330 (* MINUS *);
  331 (* PLUS *);
  332 (* STAR *);
  333 (* SLASH *);
  334 (* PERCENT *);
  335 (* LT *);
  336 (* GT *);
  337 (* HAT *);
  338 (* PIPE *);
  339 (* QUESTION *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  257 (* ANNOT *);
  258 (* IDENTIFIER *);
  259 (* CONSTANT *);
  260 (* STRING_LITERAL *);
  261 (* TYPE_NAME *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\003\000\003\000\003\000\003\000\005\000\005\000\
\005\000\005\000\005\000\005\000\005\000\005\000\006\000\006\000\
\008\000\008\000\008\000\008\000\008\000\008\000\009\000\009\000\
\009\000\009\000\009\000\009\000\010\000\010\000\012\000\012\000\
\012\000\012\000\013\000\013\000\013\000\014\000\014\000\014\000\
\015\000\015\000\015\000\015\000\015\000\016\000\016\000\016\000\
\017\000\017\000\018\000\018\000\019\000\019\000\020\000\020\000\
\021\000\021\000\022\000\022\000\007\000\007\000\023\000\023\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\023\000\
\023\000\004\000\004\000\024\000\025\000\025\000\026\000\026\000\
\026\000\026\000\026\000\026\000\027\000\027\000\031\000\031\000\
\028\000\028\000\028\000\028\000\028\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\034\000\034\000\034\000\036\000\036\000\037\000\037\000\
\038\000\039\000\039\000\039\000\039\000\040\000\040\000\041\000\
\041\000\041\000\035\000\035\000\035\000\042\000\042\000\043\000\
\043\000\030\000\030\000\032\000\032\000\045\000\045\000\045\000\
\045\000\045\000\045\000\045\000\047\000\047\000\044\000\044\000\
\044\000\044\000\049\000\049\000\046\000\046\000\050\000\050\000\
\051\000\051\000\051\000\048\000\048\000\011\000\011\000\052\000\
\052\000\052\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\033\000\033\000\033\000\054\000\054\000\
\055\000\055\000\055\000\055\000\055\000\055\000\056\000\056\000\
\056\000\057\000\057\000\057\000\057\000\064\000\063\000\063\000\
\062\000\062\000\058\000\058\000\059\000\059\000\059\000\060\000\
\060\000\060\000\060\000\061\000\061\000\061\000\061\000\061\000\
\002\000\002\000\065\000\065\000\066\000\066\000\066\000\066\000\
\000\000"

let yylen = "\002\000\
\002\000\001\000\001\000\001\000\001\000\003\000\001\000\004\000\
\003\000\004\000\003\000\003\000\002\000\002\000\001\000\003\000\
\001\000\002\000\002\000\002\000\002\000\004\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\004\000\001\000\003\000\
\003\000\003\000\001\000\003\000\003\000\001\000\003\000\003\000\
\001\000\003\000\003\000\003\000\003\000\001\000\003\000\003\000\
\001\000\003\000\001\000\003\000\001\000\003\000\001\000\003\000\
\001\000\003\000\001\000\005\000\001\000\003\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\003\000\001\000\002\000\003\000\001\000\002\000\
\001\000\002\000\001\000\002\000\001\000\003\000\001\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\005\000\004\000\002\000\001\000\001\000\001\000\002\000\
\003\000\002\000\001\000\002\000\001\000\001\000\003\000\001\000\
\002\000\003\000\004\000\005\000\002\000\001\000\003\000\001\000\
\003\000\001\000\001\000\002\000\001\000\001\000\003\000\004\000\
\003\000\005\000\004\000\004\000\001\000\000\000\001\000\002\000\
\002\000\003\000\001\000\002\000\001\000\003\000\001\000\003\000\
\002\000\002\000\001\000\001\000\003\000\001\000\002\000\001\000\
\001\000\002\000\003\000\002\000\003\000\003\000\004\000\002\000\
\003\000\003\000\004\000\001\000\003\000\004\000\001\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\003\000\004\000\
\003\000\002\000\003\000\003\000\004\000\003\000\001\000\002\000\
\001\000\002\000\001\000\002\000\005\000\007\000\005\000\005\000\
\007\000\006\000\007\000\003\000\002\000\002\000\002\000\003\000\
\001\000\002\000\001\000\001\000\004\000\003\000\003\000\002\000\
\002\000"

let yydefred = "\000\000\
\000\000\000\000\134\000\105\000\089\000\090\000\091\000\092\000\
\093\000\095\000\096\000\097\000\098\000\101\000\102\000\099\000\
\100\000\130\000\131\000\094\000\109\000\110\000\000\000\000\000\
\000\000\002\000\217\000\000\000\212\000\000\000\000\000\000\000\
\000\000\000\000\103\000\104\000\000\000\000\000\000\000\209\000\
\211\000\000\000\000\000\000\000\147\000\145\000\000\000\001\000\
\210\000\077\000\000\000\085\000\000\000\080\000\082\000\084\000\
\000\000\191\000\000\000\216\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\126\000\135\000\148\000\
\146\000\078\000\000\000\000\000\214\000\000\000\000\000\004\000\
\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\195\000\
\186\000\000\000\023\000\028\000\027\000\026\000\025\000\024\000\
\007\000\000\000\000\000\074\000\000\000\000\000\031\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\061\000\193\000\177\000\178\000\179\000\180\000\181\000\
\182\000\000\000\000\000\000\000\192\000\215\000\000\000\000\000\
\000\000\000\000\111\000\000\000\156\000\000\000\000\000\000\000\
\000\000\000\000\151\000\003\000\137\000\029\000\076\000\000\000\
\000\000\000\000\123\000\000\000\086\000\000\000\172\000\088\000\
\213\000\000\000\000\000\021\000\000\000\018\000\019\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\205\000\
\206\000\207\000\000\000\000\000\000\000\000\000\196\000\000\000\
\000\000\013\000\014\000\000\000\000\000\000\000\064\000\065\000\
\066\000\067\000\068\000\069\000\070\000\071\000\072\000\073\000\
\063\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\187\000\194\000\
\188\000\000\000\000\000\114\000\116\000\107\000\112\000\000\000\
\000\000\000\000\118\000\141\000\140\000\000\000\000\000\153\000\
\000\000\154\000\000\000\000\000\000\000\139\000\000\000\136\000\
\124\000\129\000\127\000\175\000\000\000\183\000\000\000\000\000\
\185\000\000\000\000\000\000\000\000\000\000\000\204\000\208\000\
\006\000\000\000\000\000\000\000\159\000\075\000\012\000\009\000\
\000\000\015\000\000\000\011\000\062\000\032\000\033\000\034\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\189\000\106\000\121\000\000\000\113\000\000\000\168\000\000\000\
\000\000\164\000\000\000\000\000\000\000\000\000\138\000\157\000\
\150\000\152\000\173\000\000\000\022\000\184\000\000\000\000\000\
\000\000\000\000\000\000\030\000\000\000\010\000\008\000\000\000\
\122\000\119\000\169\000\163\000\165\000\170\000\000\000\166\000\
\000\000\174\000\176\000\000\000\199\000\200\000\000\000\000\000\
\000\000\016\000\060\000\171\000\167\000\000\000\000\000\202\000\
\000\000\198\000\201\000\203\000"

let yydgoto = "\002\000\
\027\000\028\000\105\000\106\000\107\000\017\001\108\000\109\000\
\110\000\111\000\181\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\119\000\120\000\121\000\122\000\202\000\152\000\
\058\000\059\000\051\000\031\000\032\000\033\000\052\000\034\000\
\160\000\035\000\036\000\037\000\138\000\139\000\140\000\234\000\
\235\000\069\000\070\000\038\000\039\000\048\001\237\000\145\000\
\047\000\146\000\147\000\049\001\243\000\253\000\123\000\124\000\
\125\000\126\000\127\000\128\000\129\000\130\000\061\000\000\000\
\040\000\041\000"

let yysindex = "\037\000\
\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\014\255\143\255\
\141\255\000\000\000\000\020\000\000\000\016\255\099\007\099\007\
\099\007\037\007\000\000\000\000\033\255\017\255\211\254\000\000\
\000\000\240\254\063\255\248\254\000\000\000\000\141\255\000\000\
\000\000\000\000\236\254\000\000\209\006\000\000\000\000\000\000\
\221\000\000\000\016\255\000\000\037\007\035\255\010\007\211\254\
\045\006\060\255\063\255\036\255\213\255\000\000\000\000\000\000\
\000\000\000\000\143\255\146\002\000\000\037\007\061\255\000\000\
\000\000\234\002\006\003\006\003\053\003\111\255\152\255\160\255\
\163\255\070\002\198\255\179\255\178\255\217\255\175\002\000\000\
\000\000\115\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\247\254\127\000\000\000\079\000\053\003\000\000\017\000\
\049\000\187\255\044\255\114\000\211\255\203\255\003\000\094\000\
\008\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\235\001\040\001\047\000\000\000\000\000\010\007\010\007\
\010\007\157\003\000\000\144\255\000\000\117\000\072\255\053\000\
\076\255\051\000\000\000\000\000\000\000\000\000\000\000\058\000\
\068\000\053\003\000\000\063\255\000\000\146\002\000\000\000\000\
\000\000\070\002\115\001\000\000\053\003\000\000\000\000\081\000\
\070\002\053\003\053\003\053\003\124\000\207\002\110\000\000\000\
\000\000\000\000\051\255\123\255\129\000\146\255\000\000\053\003\
\192\000\000\000\000\000\186\002\053\003\196\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\053\003\000\000\053\003\053\003\053\003\053\003\053\003\
\053\003\053\003\053\003\053\003\053\003\053\003\053\003\053\003\
\053\003\053\003\053\003\053\003\053\003\053\003\000\000\000\000\
\000\000\009\002\251\006\000\000\000\000\000\000\000\000\053\003\
\142\000\057\255\000\000\000\000\000\000\130\002\237\000\000\000\
\108\255\000\000\182\255\117\000\201\000\000\000\079\007\000\000\
\000\000\000\000\000\000\000\000\070\000\000\000\144\000\070\002\
\000\000\137\255\158\255\161\255\146\000\207\002\000\000\000\000\
\000\000\053\003\191\004\190\255\000\000\000\000\000\000\000\000\
\164\255\000\000\229\254\000\000\000\000\000\000\000\000\000\000\
\017\000\017\000\049\000\049\000\187\255\187\255\187\255\187\255\
\044\255\044\255\114\000\211\255\203\255\003\000\094\000\074\000\
\000\000\000\000\000\000\053\003\000\000\144\255\000\000\161\000\
\164\000\000\000\163\000\182\255\190\006\056\001\000\000\000\000\
\000\000\000\000\000\000\113\000\000\000\000\000\070\002\070\002\
\070\002\053\003\221\002\000\000\053\003\000\000\000\000\053\003\
\000\000\000\000\000\000\000\000\000\000\000\000\166\000\000\000\
\165\000\000\000\000\000\184\000\000\000\000\000\205\255\070\002\
\207\255\000\000\000\000\000\000\000\000\070\002\176\000\000\000\
\070\002\000\000\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\013\000\000\000\000\000\000\000\000\000\000\000\037\255\125\255\
\139\255\000\000\000\000\000\000\000\000\000\000\106\006\000\000\
\000\000\134\001\000\000\000\000\000\000\000\000\021\000\000\000\
\000\000\000\000\000\000\000\000\084\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\190\001\000\000\148\006\
\000\000\000\000\000\000\077\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\139\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\073\003\000\000\097\003\000\000\000\000\171\003\
\037\004\226\004\118\005\231\003\109\000\210\005\153\003\098\004\
\078\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\084\255\000\000\000\000\000\000\166\255\
\007\000\000\000\000\000\000\000\000\000\064\006\005\000\000\000\
\000\000\170\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\171\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\180\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\015\000\000\000\044\000\064\006\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\175\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\195\003\013\004\111\004\135\004\000\005\030\005\060\005\090\005\
\148\005\176\005\073\004\186\005\218\005\000\004\235\005\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\046\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\040\002\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\000\000\024\000\000\000\000\000\184\255\201\255\
\000\000\159\255\081\001\190\000\214\000\115\255\241\000\030\001\
\050\001\029\001\064\001\065\001\000\000\195\255\000\000\197\255\
\006\000\016\000\000\000\000\000\208\255\045\001\210\001\234\255\
\110\255\000\000\000\000\000\000\153\001\127\255\199\255\000\000\
\243\000\223\001\135\001\241\255\218\255\194\255\063\001\000\000\
\000\000\000\000\070\001\135\255\046\255\000\000\172\255\000\000\
\255\255\096\255\000\000\000\000\000\000\188\001\204\000\000\000\
\038\002\000\000"

let yytablesize = 2193
let yytable = "\064\000\
\026\000\044\000\144\000\159\000\151\000\173\000\029\000\053\000\
\231\000\046\000\150\000\252\000\203\000\006\001\136\000\042\000\
\030\000\003\000\003\000\048\000\065\000\242\000\066\000\151\000\
\221\000\168\000\164\000\166\000\167\000\150\000\052\001\073\000\
\060\000\029\000\062\000\184\000\132\000\001\000\079\000\074\000\
\182\000\071\001\075\000\030\000\067\000\224\000\054\000\055\000\
\056\000\136\000\183\000\077\000\132\000\184\000\150\000\211\000\
\212\000\052\001\071\000\134\000\013\001\148\000\080\000\081\000\
\068\000\082\000\133\000\083\000\084\000\029\001\030\001\031\001\
\032\001\003\000\043\000\050\000\161\000\254\000\228\000\229\000\
\143\000\024\000\024\000\133\000\001\001\159\000\136\000\136\000\
\136\000\136\000\222\000\025\000\151\000\063\000\250\000\135\000\
\079\000\231\000\150\000\079\000\154\000\067\001\079\000\079\000\
\079\000\182\000\022\001\023\001\024\001\003\000\008\001\014\001\
\079\000\184\000\136\000\018\001\045\001\233\000\179\000\046\001\
\240\000\180\000\213\000\214\000\162\000\098\000\081\000\241\000\
\149\000\021\001\099\000\100\000\101\000\102\000\103\000\104\000\
\133\000\238\000\245\000\239\000\083\000\224\000\246\000\087\000\
\003\000\003\000\087\000\025\000\150\000\150\000\150\000\150\000\
\150\000\150\000\150\000\150\000\150\000\150\000\150\000\150\000\
\150\000\150\000\150\000\150\000\150\000\150\000\012\001\115\000\
\068\001\083\001\151\000\062\001\043\001\238\000\169\000\239\000\
\150\000\151\000\136\000\051\001\175\000\018\000\019\000\150\000\
\081\000\184\000\180\000\081\000\180\000\009\001\081\000\081\000\
\081\000\002\001\003\001\004\001\209\000\210\000\083\000\184\000\
\081\000\083\000\064\000\063\001\083\000\083\000\083\000\232\000\
\024\000\024\000\150\000\011\001\019\001\239\000\083\000\044\000\
\025\000\170\000\025\000\025\000\184\000\025\000\241\000\184\000\
\064\001\171\000\069\001\065\001\172\000\115\000\070\001\115\000\
\115\000\115\000\084\001\085\001\086\001\176\000\151\000\120\000\
\073\001\115\000\120\000\159\000\150\000\040\001\079\001\053\001\
\151\000\054\001\081\001\012\001\090\001\143\000\150\000\011\001\
\078\000\239\000\003\000\096\001\131\000\004\000\143\000\174\000\
\117\000\098\001\091\001\184\000\100\001\184\000\143\000\095\001\
\150\000\097\001\155\000\156\000\177\000\003\000\144\000\233\000\
\004\000\217\000\143\000\218\000\005\000\006\000\007\000\008\000\
\009\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\005\000\
\006\000\007\000\008\000\009\000\010\000\011\000\012\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\155\000\143\000\045\000\117\000\155\000\
\117\000\117\000\117\000\143\000\025\000\160\000\143\000\143\000\
\143\000\160\000\117\000\144\000\219\000\024\000\144\000\144\000\
\144\000\087\001\089\001\072\000\204\000\205\000\206\000\025\000\
\191\000\192\000\193\000\194\000\195\000\196\000\197\000\198\000\
\199\000\200\000\161\000\137\000\162\000\220\000\161\000\076\000\
\162\000\247\000\148\000\080\000\081\000\236\000\082\000\244\000\
\083\000\084\000\207\000\208\000\051\000\051\000\248\000\215\000\
\216\000\249\000\156\000\059\001\060\001\185\000\186\000\187\000\
\184\000\072\001\128\000\128\000\025\001\026\001\137\000\201\000\
\000\001\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\027\001\028\001\
\051\000\007\001\051\000\051\000\051\000\158\000\082\001\051\000\
\005\001\051\000\098\000\137\000\137\000\137\000\137\000\099\000\
\100\000\101\000\102\000\103\000\104\000\051\000\051\000\051\000\
\188\000\015\001\189\000\010\001\190\000\020\001\003\000\033\001\
\034\001\003\000\056\001\003\000\003\000\044\001\003\000\137\000\
\003\000\003\000\061\001\066\001\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\079\000\080\000\
\081\000\004\000\082\000\075\001\083\000\084\000\076\001\077\001\
\092\001\093\001\094\001\099\001\149\000\158\000\148\000\080\000\
\081\000\160\000\082\000\255\000\083\000\084\000\035\001\037\001\
\005\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\036\001\085\000\086\000\087\000\137\000\
\088\000\089\000\090\000\091\000\092\000\093\000\094\000\095\000\
\096\000\057\000\097\000\038\001\157\000\039\001\098\000\227\000\
\074\001\153\000\251\000\099\000\100\000\101\000\102\000\103\000\
\104\000\079\000\080\000\081\000\004\000\082\000\098\000\083\000\
\084\000\050\001\055\001\099\000\100\000\101\000\102\000\103\000\
\104\000\148\000\080\000\081\000\058\001\082\000\226\000\083\000\
\084\000\049\000\000\000\005\000\006\000\007\000\008\000\009\000\
\010\000\011\000\012\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\000\000\085\000\
\086\000\087\000\000\000\088\000\089\000\090\000\091\000\092\000\
\093\000\094\000\095\000\096\000\057\000\225\000\000\000\000\000\
\000\000\098\000\000\000\000\000\000\000\000\000\099\000\100\000\
\101\000\102\000\103\000\104\000\148\000\080\000\081\000\004\000\
\082\000\098\000\083\000\084\000\080\001\000\000\099\000\100\000\
\101\000\102\000\103\000\104\000\000\000\000\000\000\000\125\000\
\000\000\059\000\125\000\059\000\059\000\059\000\000\000\000\000\
\059\000\000\000\059\000\010\000\011\000\012\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\125\000\125\000\125\000\125\000\125\000\125\000\125\000\
\125\000\125\000\125\000\125\000\125\000\125\000\125\000\125\000\
\125\000\125\000\125\000\125\000\098\000\000\000\000\000\000\000\
\000\000\099\000\100\000\101\000\102\000\103\000\104\000\108\000\
\000\000\125\000\108\000\000\000\125\000\125\000\000\000\125\000\
\125\000\125\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\125\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\108\000\108\000\108\000\079\000\080\000\081\000\000\000\
\082\000\000\000\083\000\084\000\000\000\000\000\000\000\000\000\
\000\000\108\000\000\000\000\000\108\000\108\000\000\000\108\000\
\108\000\108\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\108\000\079\000\080\000\081\000\000\000\082\000\000\000\
\083\000\084\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\085\000\086\000\087\000\000\000\088\000\089\000\
\090\000\091\000\092\000\093\000\094\000\095\000\096\000\057\000\
\223\000\197\000\197\000\197\000\098\000\197\000\000\000\197\000\
\197\000\099\000\100\000\101\000\102\000\103\000\104\000\000\000\
\085\000\086\000\087\000\000\000\088\000\089\000\090\000\091\000\
\092\000\093\000\094\000\095\000\096\000\057\000\041\001\079\000\
\080\000\081\000\098\000\082\000\000\000\083\000\084\000\099\000\
\100\000\101\000\102\000\103\000\104\000\000\000\000\000\197\000\
\197\000\197\000\000\000\197\000\197\000\197\000\197\000\197\000\
\197\000\197\000\197\000\197\000\197\000\197\000\000\000\000\000\
\000\000\197\000\000\000\000\000\000\000\000\000\197\000\197\000\
\197\000\197\000\197\000\197\000\000\000\085\000\086\000\087\000\
\000\000\088\000\089\000\090\000\091\000\092\000\093\000\094\000\
\095\000\096\000\057\000\003\000\000\000\000\000\004\000\098\000\
\000\000\000\000\000\000\000\000\099\000\100\000\101\000\102\000\
\103\000\104\000\000\000\148\000\080\000\081\000\000\000\082\000\
\000\000\083\000\084\000\000\000\000\000\005\000\006\000\007\000\
\008\000\009\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\148\000\080\000\081\000\000\000\082\000\000\000\083\000\084\000\
\000\000\000\000\000\000\148\000\080\000\081\000\000\000\082\000\
\000\000\083\000\084\000\238\000\047\001\239\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\025\000\158\000\000\000\
\148\000\080\000\081\000\098\000\082\000\000\000\083\000\084\000\
\099\000\100\000\101\000\102\000\103\000\104\000\148\000\080\000\
\081\000\000\000\082\000\000\000\083\000\084\000\000\000\000\000\
\000\000\000\000\178\000\148\000\080\000\081\000\000\000\082\000\
\098\000\083\000\084\000\000\000\000\000\099\000\100\000\101\000\
\102\000\103\000\104\000\098\000\016\001\000\000\000\000\000\000\
\099\000\100\000\101\000\102\000\103\000\104\000\000\000\148\000\
\080\000\081\000\096\000\082\000\000\000\083\000\084\000\000\000\
\098\000\000\000\000\000\000\000\000\000\099\000\100\000\101\000\
\102\000\103\000\104\000\000\000\000\000\000\000\098\000\088\001\
\000\000\000\000\000\000\099\000\100\000\101\000\102\000\103\000\
\104\000\000\000\000\000\163\000\000\000\000\000\000\000\000\000\
\099\000\100\000\101\000\102\000\103\000\104\000\148\000\080\000\
\081\000\000\000\082\000\000\000\083\000\084\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\
\000\000\000\000\000\000\000\000\099\000\100\000\101\000\102\000\
\103\000\104\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\000\000\000\000\000\000\000\000\
\000\000\000\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\000\000\000\000\000\000\000\000\098\000\000\000\
\000\000\000\000\000\000\099\000\100\000\101\000\102\000\103\000\
\104\000\000\000\000\000\000\000\017\000\000\000\017\000\017\000\
\017\000\017\000\000\000\017\000\000\000\017\000\000\000\017\000\
\000\000\000\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\029\000\000\000\029\000\029\000\
\029\000\004\000\000\000\029\000\000\000\029\000\000\000\029\000\
\055\000\055\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\000\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\000\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\055\000\000\000\055\000\055\000\
\055\000\000\000\230\000\055\000\000\000\055\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\035\000\000\000\
\035\000\035\000\035\000\055\000\000\000\035\000\000\000\035\000\
\000\000\035\000\000\000\000\000\035\000\035\000\049\000\049\000\
\000\000\035\000\035\000\035\000\035\000\035\000\037\000\000\000\
\037\000\037\000\037\000\000\000\000\000\037\000\000\000\037\000\
\000\000\037\000\000\000\000\000\037\000\037\000\000\000\056\000\
\056\000\037\000\037\000\037\000\037\000\037\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\000\000\000\000\
\000\000\000\000\049\000\000\000\049\000\049\000\049\000\000\000\
\000\000\049\000\000\000\049\000\000\000\049\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\000\000\049\000\
\049\000\049\000\000\000\056\000\000\000\056\000\056\000\056\000\
\000\000\000\000\056\000\000\000\056\000\000\000\000\000\000\000\
\036\000\000\000\036\000\036\000\036\000\000\000\000\000\036\000\
\000\000\036\000\056\000\036\000\000\000\000\000\036\000\036\000\
\050\000\050\000\000\000\036\000\036\000\036\000\036\000\036\000\
\038\000\000\000\038\000\038\000\038\000\000\000\000\000\038\000\
\000\000\038\000\000\000\038\000\000\000\000\000\000\000\000\000\
\000\000\000\000\057\000\038\000\038\000\038\000\038\000\038\000\
\039\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\000\000\000\000\000\000\000\000\050\000\000\000\050\000\050\000\
\050\000\000\000\000\000\050\000\000\000\050\000\000\000\050\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\000\000\050\000\050\000\050\000\000\000\057\000\000\000\057\000\
\057\000\057\000\000\000\000\000\057\000\000\000\057\000\000\000\
\000\000\000\000\039\000\000\000\039\000\039\000\039\000\000\000\
\000\000\039\000\000\000\039\000\057\000\039\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\039\000\039\000\039\000\
\039\000\039\000\040\000\004\000\040\000\040\000\040\000\000\000\
\000\000\040\000\000\000\040\000\000\000\040\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\040\000\040\000\040\000\
\040\000\040\000\005\000\006\000\007\000\008\000\009\000\010\000\
\011\000\012\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\041\000\041\000\041\000\
\041\000\041\000\041\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\011\001\047\001\239\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\025\000\044\000\044\000\044\000\044\000\044\000\
\044\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\041\000\000\000\041\000\
\041\000\041\000\000\000\000\000\041\000\000\000\041\000\000\000\
\041\000\045\000\045\000\045\000\045\000\045\000\045\000\000\000\
\041\000\041\000\041\000\041\000\041\000\000\000\000\000\000\000\
\000\000\000\000\000\000\044\000\000\000\044\000\044\000\044\000\
\000\000\000\000\044\000\000\000\044\000\000\000\044\000\042\000\
\042\000\042\000\042\000\042\000\042\000\000\000\044\000\044\000\
\044\000\044\000\044\000\000\000\000\000\000\000\000\000\000\000\
\000\000\045\000\000\000\045\000\045\000\045\000\000\000\000\000\
\045\000\000\000\045\000\000\000\045\000\043\000\043\000\043\000\
\043\000\043\000\043\000\000\000\045\000\045\000\045\000\045\000\
\045\000\000\000\000\000\000\000\000\000\000\000\000\000\042\000\
\000\000\042\000\042\000\042\000\000\000\000\000\042\000\000\000\
\042\000\000\000\042\000\046\000\046\000\046\000\046\000\000\000\
\000\000\000\000\042\000\042\000\042\000\042\000\042\000\000\000\
\000\000\000\000\000\000\000\000\000\000\043\000\000\000\043\000\
\043\000\043\000\000\000\000\000\043\000\000\000\043\000\000\000\
\043\000\047\000\047\000\047\000\047\000\000\000\000\000\000\000\
\043\000\043\000\043\000\043\000\043\000\000\000\000\000\000\000\
\000\000\046\000\000\000\046\000\046\000\046\000\000\000\000\000\
\046\000\000\000\046\000\000\000\046\000\048\000\048\000\048\000\
\048\000\000\000\000\000\000\000\000\000\000\000\046\000\046\000\
\046\000\052\000\052\000\000\000\000\000\000\000\000\000\047\000\
\000\000\047\000\047\000\047\000\000\000\000\000\047\000\000\000\
\047\000\000\000\047\000\000\000\000\000\000\000\000\000\000\000\
\000\000\053\000\053\000\000\000\047\000\047\000\047\000\000\000\
\000\000\054\000\054\000\048\000\000\000\048\000\048\000\048\000\
\000\000\000\000\048\000\000\000\048\000\052\000\048\000\052\000\
\052\000\052\000\000\000\058\000\052\000\000\000\052\000\000\000\
\048\000\048\000\048\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\052\000\052\000\052\000\053\000\000\000\053\000\
\053\000\053\000\000\000\000\000\053\000\054\000\053\000\054\000\
\054\000\054\000\000\000\000\000\054\000\000\000\054\000\000\000\
\000\000\000\000\000\000\053\000\053\000\000\000\058\000\000\000\
\058\000\058\000\058\000\054\000\054\000\058\000\141\000\058\000\
\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\058\000\000\000\000\000\
\000\000\000\000\000\000\000\000\142\000\000\000\000\000\000\000\
\005\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\133\000\142\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\142\000\142\000\000\000\142\000\142\000\
\142\000\142\000\142\000\142\000\000\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\133\000\133\000\000\000\
\133\000\133\000\133\000\000\000\133\000\000\000\000\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\132\000\132\000\132\000\132\000\132\000\132\000\
\132\000\132\000\004\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\132\000\
\132\000\000\000\132\000\132\000\132\000\004\000\132\000\000\000\
\000\000\005\000\006\000\007\000\008\000\009\000\010\000\011\000\
\012\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\005\000\006\000\007\000\008\000\
\009\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\004\000\
\078\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\057\000\004\000\000\000\
\000\000\076\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\012\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\004\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\042\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\005\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\004\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\057\000\000\000\000\000\000\000\000\000\000\000\004\000\
\000\000\000\000\005\000\006\000\007\000\008\000\009\000\010\000\
\011\000\012\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\057\001\005\000\006\000\
\007\000\008\000\009\000\010\000\011\000\012\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000"

let yycheck = "\038\000\
\000\000\024\000\065\000\076\000\066\000\090\000\001\000\030\000\
\138\000\025\000\066\000\158\000\110\000\174\000\063\000\002\001\
\001\000\002\001\002\001\000\000\066\001\143\000\068\001\085\000\
\017\001\085\000\082\000\083\000\084\000\085\000\241\000\047\000\
\034\000\028\000\002\001\063\001\059\000\001\000\002\001\060\001\
\098\000\069\001\063\001\028\000\061\001\130\000\031\000\032\000\
\033\000\098\000\060\001\053\000\075\000\063\001\110\000\012\001\
\013\001\012\001\067\001\061\000\182\000\002\001\003\001\004\001\
\002\001\006\001\061\000\008\001\009\001\211\000\212\000\213\000\
\214\000\002\001\061\001\060\001\078\000\162\000\136\000\137\000\
\065\000\066\001\066\001\078\000\169\000\158\000\135\000\136\000\
\137\000\138\000\083\001\076\001\154\000\061\001\154\000\061\001\
\060\001\227\000\154\000\063\001\065\001\006\001\066\001\067\001\
\068\001\163\000\204\000\205\000\206\000\002\001\060\001\184\000\
\076\001\063\001\163\000\188\000\060\001\140\000\095\000\063\001\
\143\000\098\000\079\001\080\001\064\001\066\001\002\001\143\000\
\069\001\202\000\071\001\072\001\073\001\074\001\075\001\076\001\
\131\000\066\001\063\001\068\001\002\001\226\000\067\001\060\001\
\002\001\002\001\063\001\076\001\204\000\205\000\206\000\207\000\
\208\000\209\000\210\000\211\000\212\000\213\000\214\000\215\000\
\216\000\217\000\218\000\219\000\220\000\221\000\182\000\002\001\
\010\001\060\001\232\000\000\001\232\000\066\001\064\001\068\001\
\232\000\239\000\227\000\239\000\002\001\041\001\042\001\239\000\
\060\001\063\001\163\000\063\001\165\000\067\001\066\001\067\001\
\068\001\170\000\171\000\172\000\010\001\011\001\060\001\063\001\
\076\001\063\001\241\000\067\001\066\001\067\001\068\001\064\001\
\066\001\066\001\010\001\066\001\189\000\068\001\076\001\238\000\
\076\001\066\001\076\001\076\001\063\001\076\001\238\000\063\001\
\067\001\066\001\063\001\067\001\066\001\064\001\067\001\066\001\
\067\001\068\001\063\001\064\001\065\001\060\001\044\001\060\001\
\044\001\076\001\063\001\060\001\044\001\222\000\053\001\066\001\
\054\001\068\001\054\001\011\001\069\001\238\000\054\001\066\001\
\053\000\068\001\002\001\088\001\057\000\005\001\247\000\066\001\
\002\001\094\001\072\001\063\001\097\001\063\001\002\001\067\001\
\072\001\067\001\062\001\063\001\060\001\002\001\002\001\046\001\
\005\001\071\001\011\001\081\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\066\001\063\001\053\001\025\000\064\001\067\001\
\066\001\067\001\068\001\063\001\076\001\063\001\066\001\067\001\
\068\001\067\001\076\001\063\001\082\001\066\001\066\001\067\001\
\068\001\066\001\067\001\047\000\076\001\077\001\078\001\076\001\
\018\001\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\063\001\063\000\063\001\016\001\067\001\065\001\
\067\001\063\001\002\001\003\001\004\001\001\001\006\001\067\001\
\008\001\009\001\074\001\075\001\016\001\017\001\069\001\014\001\
\015\001\062\001\063\001\062\001\063\001\007\001\008\001\009\001\
\063\001\064\001\062\001\063\001\207\000\208\000\098\000\065\001\
\064\001\007\001\008\001\009\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\209\000\210\000\
\060\001\060\001\062\001\063\001\064\001\061\001\062\001\067\001\
\053\001\069\001\066\001\135\000\136\000\137\000\138\000\071\001\
\072\001\073\001\074\001\075\001\076\001\081\001\082\001\083\001\
\066\001\002\001\068\001\067\001\070\001\002\001\060\001\215\000\
\216\000\063\001\002\001\065\001\066\001\064\001\068\001\163\000\
\070\001\071\001\067\001\066\001\074\001\075\001\076\001\077\001\
\078\001\079\001\080\001\081\001\082\001\083\001\002\001\003\001\
\004\001\005\001\006\001\067\001\008\001\009\001\067\001\069\001\
\067\001\069\001\051\001\060\001\067\001\067\001\002\001\003\001\
\004\001\067\001\006\001\163\000\008\001\009\001\217\000\219\000\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\218\000\048\001\049\001\050\001\227\000\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\062\001\220\000\075\000\221\000\066\001\135\000\
\046\001\067\000\156\000\071\001\072\001\073\001\074\001\075\001\
\076\001\002\001\003\001\004\001\005\001\006\001\066\001\008\001\
\009\001\069\001\244\000\071\001\072\001\073\001\074\001\075\001\
\076\001\002\001\003\001\004\001\247\000\006\001\131\000\008\001\
\009\001\028\000\255\255\028\001\029\001\030\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\255\255\048\001\
\049\001\050\001\255\255\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\062\001\255\255\255\255\
\255\255\066\001\255\255\255\255\255\255\255\255\071\001\072\001\
\073\001\074\001\075\001\076\001\002\001\003\001\004\001\005\001\
\006\001\066\001\008\001\009\001\069\001\255\255\071\001\072\001\
\073\001\074\001\075\001\076\001\255\255\255\255\255\255\002\001\
\255\255\060\001\005\001\062\001\063\001\064\001\255\255\255\255\
\067\001\255\255\069\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\066\001\255\255\255\255\255\255\
\255\255\071\001\072\001\073\001\074\001\075\001\076\001\002\001\
\255\255\060\001\005\001\255\255\063\001\064\001\255\255\066\001\
\067\001\068\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\076\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\002\001\003\001\004\001\255\255\
\006\001\255\255\008\001\009\001\255\255\255\255\255\255\255\255\
\255\255\060\001\255\255\255\255\063\001\064\001\255\255\066\001\
\067\001\068\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\076\001\002\001\003\001\004\001\255\255\006\001\255\255\
\008\001\009\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\048\001\049\001\050\001\255\255\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\062\001\002\001\003\001\004\001\066\001\006\001\255\255\008\001\
\009\001\071\001\072\001\073\001\074\001\075\001\076\001\255\255\
\048\001\049\001\050\001\255\255\052\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\002\001\
\003\001\004\001\066\001\006\001\255\255\008\001\009\001\071\001\
\072\001\073\001\074\001\075\001\076\001\255\255\255\255\048\001\
\049\001\050\001\255\255\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\061\001\062\001\255\255\255\255\
\255\255\066\001\255\255\255\255\255\255\255\255\071\001\072\001\
\073\001\074\001\075\001\076\001\255\255\048\001\049\001\050\001\
\255\255\052\001\053\001\054\001\055\001\056\001\057\001\058\001\
\059\001\060\001\061\001\002\001\255\255\255\255\005\001\066\001\
\255\255\255\255\255\255\255\255\071\001\072\001\073\001\074\001\
\075\001\076\001\255\255\002\001\003\001\004\001\255\255\006\001\
\255\255\008\001\009\001\255\255\255\255\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\002\001\003\001\004\001\255\255\006\001\255\255\008\001\009\001\
\255\255\255\255\255\255\002\001\003\001\004\001\255\255\006\001\
\255\255\008\001\009\001\066\001\067\001\068\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\076\001\061\001\255\255\
\002\001\003\001\004\001\066\001\006\001\255\255\008\001\009\001\
\071\001\072\001\073\001\074\001\075\001\076\001\002\001\003\001\
\004\001\255\255\006\001\255\255\008\001\009\001\255\255\255\255\
\255\255\255\255\060\001\002\001\003\001\004\001\255\255\006\001\
\066\001\008\001\009\001\255\255\255\255\071\001\072\001\073\001\
\074\001\075\001\076\001\066\001\067\001\255\255\255\255\255\255\
\071\001\072\001\073\001\074\001\075\001\076\001\255\255\002\001\
\003\001\004\001\060\001\006\001\255\255\008\001\009\001\255\255\
\066\001\255\255\255\255\255\255\255\255\071\001\072\001\073\001\
\074\001\075\001\076\001\255\255\255\255\255\255\066\001\067\001\
\255\255\255\255\255\255\071\001\072\001\073\001\074\001\075\001\
\076\001\255\255\255\255\066\001\255\255\255\255\255\255\255\255\
\071\001\072\001\073\001\074\001\075\001\076\001\002\001\003\001\
\004\001\255\255\006\001\255\255\008\001\009\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\066\001\
\255\255\255\255\255\255\255\255\071\001\072\001\073\001\074\001\
\075\001\076\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\255\255\255\255\255\255\255\255\
\255\255\255\255\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\255\255\255\255\255\255\255\255\066\001\255\255\
\255\255\255\255\255\255\071\001\072\001\073\001\074\001\075\001\
\076\001\255\255\255\255\255\255\060\001\255\255\062\001\063\001\
\064\001\065\001\255\255\067\001\255\255\069\001\255\255\071\001\
\255\255\255\255\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\060\001\255\255\062\001\063\001\
\064\001\005\001\255\255\067\001\255\255\069\001\255\255\071\001\
\016\001\017\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\255\255\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\255\255\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\060\001\255\255\062\001\063\001\
\064\001\255\255\062\001\067\001\255\255\069\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\060\001\255\255\
\062\001\063\001\064\001\083\001\255\255\067\001\255\255\069\001\
\255\255\071\001\255\255\255\255\074\001\075\001\016\001\017\001\
\255\255\079\001\080\001\081\001\082\001\083\001\060\001\255\255\
\062\001\063\001\064\001\255\255\255\255\067\001\255\255\069\001\
\255\255\071\001\255\255\255\255\074\001\075\001\255\255\016\001\
\017\001\079\001\080\001\081\001\082\001\083\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\255\255\255\255\
\255\255\255\255\060\001\255\255\062\001\063\001\064\001\255\255\
\255\255\067\001\255\255\069\001\255\255\071\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\255\255\081\001\
\082\001\083\001\255\255\060\001\255\255\062\001\063\001\064\001\
\255\255\255\255\067\001\255\255\069\001\255\255\255\255\255\255\
\060\001\255\255\062\001\063\001\064\001\255\255\255\255\067\001\
\255\255\069\001\083\001\071\001\255\255\255\255\074\001\075\001\
\016\001\017\001\255\255\079\001\080\001\081\001\082\001\083\001\
\060\001\255\255\062\001\063\001\064\001\255\255\255\255\067\001\
\255\255\069\001\255\255\071\001\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\079\001\080\001\081\001\082\001\083\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\255\255\255\255\255\255\255\255\060\001\255\255\062\001\063\001\
\064\001\255\255\255\255\067\001\255\255\069\001\255\255\071\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\255\255\081\001\082\001\083\001\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\255\255\255\255\060\001\255\255\062\001\063\001\064\001\255\255\
\255\255\067\001\255\255\069\001\083\001\071\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\079\001\080\001\081\001\
\082\001\083\001\060\001\005\001\062\001\063\001\064\001\255\255\
\255\255\067\001\255\255\069\001\255\255\071\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\079\001\080\001\081\001\
\082\001\083\001\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\012\001\013\001\014\001\
\015\001\016\001\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\066\001\067\001\068\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\076\001\012\001\013\001\014\001\015\001\016\001\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\071\001\012\001\013\001\014\001\015\001\016\001\017\001\255\255\
\079\001\080\001\081\001\082\001\083\001\255\255\255\255\255\255\
\255\255\255\255\255\255\060\001\255\255\062\001\063\001\064\001\
\255\255\255\255\067\001\255\255\069\001\255\255\071\001\012\001\
\013\001\014\001\015\001\016\001\017\001\255\255\079\001\080\001\
\081\001\082\001\083\001\255\255\255\255\255\255\255\255\255\255\
\255\255\060\001\255\255\062\001\063\001\064\001\255\255\255\255\
\067\001\255\255\069\001\255\255\071\001\012\001\013\001\014\001\
\015\001\016\001\017\001\255\255\079\001\080\001\081\001\082\001\
\083\001\255\255\255\255\255\255\255\255\255\255\255\255\060\001\
\255\255\062\001\063\001\064\001\255\255\255\255\067\001\255\255\
\069\001\255\255\071\001\014\001\015\001\016\001\017\001\255\255\
\255\255\255\255\079\001\080\001\081\001\082\001\083\001\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\071\001\014\001\015\001\016\001\017\001\255\255\255\255\255\255\
\079\001\080\001\081\001\082\001\083\001\255\255\255\255\255\255\
\255\255\060\001\255\255\062\001\063\001\064\001\255\255\255\255\
\067\001\255\255\069\001\255\255\071\001\014\001\015\001\016\001\
\017\001\255\255\255\255\255\255\255\255\255\255\081\001\082\001\
\083\001\016\001\017\001\255\255\255\255\255\255\255\255\060\001\
\255\255\062\001\063\001\064\001\255\255\255\255\067\001\255\255\
\069\001\255\255\071\001\255\255\255\255\255\255\255\255\255\255\
\255\255\016\001\017\001\255\255\081\001\082\001\083\001\255\255\
\255\255\016\001\017\001\060\001\255\255\062\001\063\001\064\001\
\255\255\255\255\067\001\255\255\069\001\060\001\071\001\062\001\
\063\001\064\001\255\255\017\001\067\001\255\255\069\001\255\255\
\081\001\082\001\083\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\081\001\082\001\083\001\060\001\255\255\062\001\
\063\001\064\001\255\255\255\255\067\001\060\001\069\001\062\001\
\063\001\064\001\255\255\255\255\067\001\255\255\069\001\255\255\
\255\255\255\255\255\255\082\001\083\001\255\255\060\001\255\255\
\062\001\063\001\064\001\082\001\083\001\067\001\002\001\069\001\
\255\255\005\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\083\001\255\255\255\255\
\255\255\255\255\255\255\255\255\005\001\255\255\255\255\255\255\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\028\001\029\001\030\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\005\001\067\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\060\001\061\001\255\255\063\001\064\001\
\065\001\066\001\067\001\068\001\255\255\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\005\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\061\001\255\255\
\063\001\064\001\065\001\255\255\067\001\255\255\255\255\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\005\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\060\001\
\061\001\255\255\063\001\064\001\065\001\005\001\067\001\255\255\
\255\255\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\005\001\
\067\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\061\001\005\001\255\255\
\255\255\065\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\005\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\062\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\005\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\061\001\255\255\255\255\255\255\255\255\255\255\005\001\
\255\255\255\255\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001"

let yynames_const = "\
  SIZEOF\000\
  PTR_OP\000\
  INC_OP\000\
  DEC_OP\000\
  LEFT_OP\000\
  RIGHT_OP\000\
  LE_OP\000\
  GE_OP\000\
  EQ_OP\000\
  NE_OP\000\
  AND_OP\000\
  OR_OP\000\
  MUL_ASSIGN\000\
  DIV_ASSIGN\000\
  MOD_ASSIGN\000\
  ADD_ASSIGN\000\
  SUB_ASSIGN\000\
  LEFT_ASSIGN\000\
  RIGHT_ASSIGN\000\
  AND_ASSIGN\000\
  XOR_ASSIGN\000\
  OR_ASSIGN\000\
  TYPEDEF\000\
  EXTERN\000\
  STATIC\000\
  AUTO\000\
  REGISTER\000\
  CHAR\000\
  SHORT\000\
  INT\000\
  LONG\000\
  SIGNED\000\
  UNSIGNED\000\
  FLOAT\000\
  DOUBLE\000\
  CONST\000\
  VOLATILE\000\
  VOID\000\
  STRUCT\000\
  UNION\000\
  ENUM\000\
  ELLIPSIS\000\
  CASE\000\
  DEFAULT\000\
  IF\000\
  ELSE\000\
  SWITCH\000\
  WHILE\000\
  DO\000\
  FOR\000\
  GOTO\000\
  CONTINUE\000\
  BREAK\000\
  RETURN\000\
  SEMICOLON\000\
  LBRACE\000\
  RBRACE\000\
  COMMA\000\
  COLON\000\
  EQUAL\000\
  LPAR\000\
  RPAR\000\
  LSQUARE\000\
  RSQUARE\000\
  DOT\000\
  AMP\000\
  EXL\000\
  TILDE\000\
  MINUS\000\
  PLUS\000\
  STAR\000\
  SLASH\000\
  PERCENT\000\
  LT\000\
  GT\000\
  HAT\000\
  PIPE\000\
  QUESTION\000\
  EOF\000\
  "

let yynames_block = "\
  ANNOT\000\
  IDENTIFIER\000\
  CONSTANT\000\
  STRING_LITERAL\000\
  TYPE_NAME\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'translation_unit) in
    Obj.repr((
# 57 "src/cparser.mly"
                                 _1 ) : Cast.file))
; (fun parser_env ->
    Obj.repr((
# 58 "src/cparser.mly"
                [] ) : Cast.file))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 62 "src/cparser.mly"
                       CEvar (loc (), Ident.create _1) ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 63 "src/cparser.mly"
                     uns() ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 64 "src/cparser.mly"
                           uns() ) : 'primary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 65 "src/cparser.mly"
                                 _2 ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'primary_expression) in
    Obj.repr((
# 69 "src/cparser.mly"
                               ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'postfix_expression) in
    let _3 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 70 "src/cparser.mly"
                                                          ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    Obj.repr((
# 71 "src/cparser.mly"
                                         ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'postfix_expression) in
    let _3 = (peek_val parser_env 1 : 'argument_expression_list) in
    Obj.repr((
# 72 "src/cparser.mly"
                                                                  ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 73 "src/cparser.mly"
                                              ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 74 "src/cparser.mly"
                                                 ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'postfix_expression) in
    Obj.repr((
# 75 "src/cparser.mly"
                                      ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'postfix_expression) in
    Obj.repr((
# 76 "src/cparser.mly"
                                      ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 80 "src/cparser.mly"
                                  ) : 'argument_expression_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'argument_expression_list) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 81 "src/cparser.mly"
                                                                 ) : 'argument_expression_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'postfix_expression) in
    Obj.repr((
# 85 "src/cparser.mly"
                               ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 86 "src/cparser.mly"
                                    ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 87 "src/cparser.mly"
                                    ) : 'unary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'unary_operator) in
    let _2 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 88 "src/cparser.mly"
                                           ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 89 "src/cparser.mly"
                                    ) : 'unary_expression))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'type_name) in
    Obj.repr((
# 90 "src/cparser.mly"
                                       ) : 'unary_expression))
; (fun parser_env ->
    Obj.repr((
# 94 "src/cparser.mly"
                ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 95 "src/cparser.mly"
                 ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 96 "src/cparser.mly"
                 ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 97 "src/cparser.mly"
                  ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 98 "src/cparser.mly"
                  ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 99 "src/cparser.mly"
                ) : 'unary_operator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 103 "src/cparser.mly"
                             ) : 'cast_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'type_name) in
    let _4 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 104 "src/cparser.mly"
                                                ) : 'cast_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 108 "src/cparser.mly"
                            ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 109 "src/cparser.mly"
                                                           ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 110 "src/cparser.mly"
                                                            ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 111 "src/cparser.mly"
                                                              ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 115 "src/cparser.mly"
                                      ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'additive_expression) in
    let _3 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 116 "src/cparser.mly"
                                                               ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'additive_expression) in
    let _3 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 117 "src/cparser.mly"
                                                                ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 121 "src/cparser.mly"
                                ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'shift_expression) in
    let _3 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 122 "src/cparser.mly"
                                                         ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'shift_expression) in
    let _3 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 123 "src/cparser.mly"
                                                          ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 127 "src/cparser.mly"
                             ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 128 "src/cparser.mly"
                                                      ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 129 "src/cparser.mly"
                                                      ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 130 "src/cparser.mly"
                                                         ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 131 "src/cparser.mly"
                                                         ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 135 "src/cparser.mly"
                                  ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equality_expression) in
    let _3 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 136 "src/cparser.mly"
                                                            ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equality_expression) in
    let _3 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 137 "src/cparser.mly"
                                                            ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'equality_expression) in
    Obj.repr((
# 141 "src/cparser.mly"
                                ) : 'and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'and_expression) in
    let _3 = (peek_val parser_env 0 : 'equality_expression) in
    Obj.repr((
# 142 "src/cparser.mly"
                                                   ) : 'and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'and_expression) in
    Obj.repr((
# 146 "src/cparser.mly"
                           ) : 'exclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'exclusive_or_expression) in
    let _3 = (peek_val parser_env 0 : 'and_expression) in
    Obj.repr((
# 147 "src/cparser.mly"
                                                       ) : 'exclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'exclusive_or_expression) in
    Obj.repr((
# 151 "src/cparser.mly"
                                    ) : 'inclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'inclusive_or_expression) in
    let _3 = (peek_val parser_env 0 : 'exclusive_or_expression) in
    Obj.repr((
# 152 "src/cparser.mly"
                                                                 ) : 'inclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'inclusive_or_expression) in
    Obj.repr((
# 156 "src/cparser.mly"
                                    ) : 'logical_and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'logical_and_expression) in
    let _3 = (peek_val parser_env 0 : 'inclusive_or_expression) in
    Obj.repr((
# 157 "src/cparser.mly"
                                                                  ) : 'logical_and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logical_and_expression) in
    Obj.repr((
# 161 "src/cparser.mly"
                                   ) : 'logical_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'logical_or_expression) in
    let _3 = (peek_val parser_env 0 : 'logical_and_expression) in
    Obj.repr((
# 162 "src/cparser.mly"
                                                               ) : 'logical_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logical_or_expression) in
    Obj.repr((
# 166 "src/cparser.mly"
                                  ) : 'conditional_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'logical_or_expression) in
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 167 "src/cparser.mly"
                                                                                   ) : 'conditional_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 171 "src/cparser.mly"
                                   uns() ) : 'assignment_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'unary_expression) in
    let _2 = (peek_val parser_env 1 : 'assignment_operator) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 172 "src/cparser.mly"
                                                                       uns() ) : 'assignment_expression))
; (fun parser_env ->
    Obj.repr((
# 176 "src/cparser.mly"
                  ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 177 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 178 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 179 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 180 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 181 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 182 "src/cparser.mly"
                        ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 183 "src/cparser.mly"
                         ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 184 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 185 "src/cparser.mly"
                       ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 186 "src/cparser.mly"
                      ) : 'assignment_operator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 190 "src/cparser.mly"
                                  _1 ) : 'expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'expression) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 191 "src/cparser.mly"
                                                   CEseq (loc(), _1, _3) ) : 'expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 195 "src/cparser.mly"
                                   ) : 'constant_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    Obj.repr((
# 199 "src/cparser.mly"
                                             uns() ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 1 : 'init_declarator_list) in
    Obj.repr((
# 201 "src/cparser.mly"
       List.map (fun d -> Ctypedecl (loc(), d, _1)) _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'storage_class_specifier) in
    Obj.repr((
# 205 "src/cparser.mly"
                                    uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'storage_class_specifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 206 "src/cparser.mly"
                                                           uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_specifier) in
    Obj.repr((
# 207 "src/cparser.mly"
                           _1 ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_specifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 208 "src/cparser.mly"
                                                  uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 209 "src/cparser.mly"
                           uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 210 "src/cparser.mly"
                                                  uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr((
# 214 "src/cparser.mly"
                            [_1] ) : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'init_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr((
# 215 "src/cparser.mly"
                                                       _1 @ [_3] ) : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 219 "src/cparser.mly"
                       _1 ) : 'init_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 220 "src/cparser.mly"
                                           uns() ) : 'init_declarator))
; (fun parser_env ->
    Obj.repr((
# 224 "src/cparser.mly"
                    ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 225 "src/cparser.mly"
                   ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 226 "src/cparser.mly"
                   ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 227 "src/cparser.mly"
                 ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 228 "src/cparser.mly"
                     ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 232 "src/cparser.mly"
                 PTunit ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 233 "src/cparser.mly"
                 PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 234 "src/cparser.mly"
                  PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 235 "src/cparser.mly"
                PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 236 "src/cparser.mly"
                 PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 237 "src/cparser.mly"
                  PTfloat ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 238 "src/cparser.mly"
                   PTfloat ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 239 "src/cparser.mly"
                   uns() ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 240 "src/cparser.mly"
                     uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_or_union_specifier) in
    Obj.repr((
# 241 "src/cparser.mly"
                                      uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'enum_specifier) in
    Obj.repr((
# 242 "src/cparser.mly"
                           uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 243 "src/cparser.mly"
                      PTexternal (Ident.create _1) ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'struct_or_union) in
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'struct_declaration_list) in
    Obj.repr((
# 247 "src/cparser.mly"
                                                                             ) : 'struct_or_union_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'struct_or_union) in
    let _3 = (peek_val parser_env 1 : 'struct_declaration_list) in
    Obj.repr((
# 248 "src/cparser.mly"
                                                                  ) : 'struct_or_union_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'struct_or_union) in
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 249 "src/cparser.mly"
                                       ) : 'struct_or_union_specifier))
; (fun parser_env ->
    Obj.repr((
# 253 "src/cparser.mly"
                   ) : 'struct_or_union))
; (fun parser_env ->
    Obj.repr((
# 254 "src/cparser.mly"
                  ) : 'struct_or_union))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_declaration) in
    Obj.repr((
# 258 "src/cparser.mly"
                               ) : 'struct_declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'struct_declaration_list) in
    let _2 = (peek_val parser_env 0 : 'struct_declaration) in
    Obj.repr((
# 259 "src/cparser.mly"
                                                       ) : 'struct_declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'specifier_qualifier_list) in
    let _2 = (peek_val parser_env 1 : 'struct_declarator_list) in
    Obj.repr((
# 263 "src/cparser.mly"
                                                                      ) : 'struct_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_specifier) in
    let _2 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 267 "src/cparser.mly"
                                                    ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_specifier) in
    Obj.repr((
# 268 "src/cparser.mly"
                           ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier) in
    let _2 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 269 "src/cparser.mly"
                                                    ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 270 "src/cparser.mly"
                           ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_declarator) in
    Obj.repr((
# 274 "src/cparser.mly"
                              ) : 'struct_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'struct_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'struct_declarator) in
    Obj.repr((
# 275 "src/cparser.mly"
                                                           ) : 'struct_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 279 "src/cparser.mly"
                       ) : 'struct_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 280 "src/cparser.mly"
                                      ) : 'struct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 281 "src/cparser.mly"
                                                 ) : 'struct_declarator))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'enumerator_list) in
    Obj.repr((
# 285 "src/cparser.mly"
                                               ) : 'enum_specifier))
; (fun parser_env ->
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'enumerator_list) in
    Obj.repr((
# 286 "src/cparser.mly"
                                                          ) : 'enum_specifier))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 287 "src/cparser.mly"
                            ) : 'enum_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'enumerator) in
    Obj.repr((
# 291 "src/cparser.mly"
                       ) : 'enumerator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'enumerator_list) in
    let _3 = (peek_val parser_env 0 : 'enumerator) in
    Obj.repr((
# 292 "src/cparser.mly"
                                             ) : 'enumerator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 296 "src/cparser.mly"
                       ) : 'enumerator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 297 "src/cparser.mly"
                                                 ) : 'enumerator))
; (fun parser_env ->
    Obj.repr((
# 301 "src/cparser.mly"
                  ) : 'type_qualifier))
; (fun parser_env ->
    Obj.repr((
# 302 "src/cparser.mly"
                     ) : 'type_qualifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'pointer) in
    let _2 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr((
# 306 "src/cparser.mly"
                                      uns() ) : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr((
# 307 "src/cparser.mly"
                              _1 ) : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 312 "src/cparser.mly"
              CDvar (Ident.create _1) ) : 'direct_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'declarator) in
    Obj.repr((
# 314 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 316 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_declarator) in
    Obj.repr((
# 318 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'direct_declarator) in
    let _3 = (peek_val parser_env 2 : 'parameter_type_list) in
    let _5 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 320 "src/cparser.mly"
       match _1 with CDvar id -> CDfun (id, _3, _5) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'identifier_list) in
    Obj.repr((
# 322 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _4 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 324 "src/cparser.mly"
              match _1 with CDvar id -> CDfun (id, [], _4) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int * string) in
    Obj.repr((
# 329 "src/cparser.mly"
                          Some _1 ) : 'annot))
; (fun parser_env ->
    Obj.repr((
# 330 "src/cparser.mly"
                          None ) : 'annot))
; (fun parser_env ->
    Obj.repr((
# 334 "src/cparser.mly"
                 ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'type_qualifier_list) in
    Obj.repr((
# 335 "src/cparser.mly"
                                     ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 336 "src/cparser.mly"
                         ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'type_qualifier_list) in
    let _3 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 337 "src/cparser.mly"
                                             ) : 'pointer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 341 "src/cparser.mly"
                           ) : 'type_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier_list) in
    let _2 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 342 "src/cparser.mly"
                                               ) : 'type_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter_list) in
    Obj.repr((
# 347 "src/cparser.mly"
                           _1 ) : 'parameter_type_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter_list) in
    Obj.repr((
# 348 "src/cparser.mly"
                                          uns() ) : 'parameter_type_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter_declaration) in
    Obj.repr((
# 352 "src/cparser.mly"
                                  [_1] ) : 'parameter_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter_list) in
    let _3 = (peek_val parser_env 0 : 'parameter_declaration) in
    Obj.repr((
# 353 "src/cparser.mly"
                                                       _1 @ [_3] ) : 'parameter_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 358 "src/cparser.mly"
              (_1, match _2 with CDvar id -> id | _ -> uns()) ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 0 : 'abstract_declarator) in
    Obj.repr((
# 359 "src/cparser.mly"
                                                       uns() ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 360 "src/cparser.mly"
                                   (_1, Ident.anonymous) ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 364 "src/cparser.mly"
                       ) : 'identifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'identifier_list) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 365 "src/cparser.mly"
                                             ) : 'identifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 369 "src/cparser.mly"
                                     ) : 'type_name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'specifier_qualifier_list) in
    let _2 = (peek_val parser_env 0 : 'abstract_declarator) in
    Obj.repr((
# 370 "src/cparser.mly"
                                                         ) : 'type_name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 374 "src/cparser.mly"
                    ) : 'abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr((
# 375 "src/cparser.mly"
                                       ) : 'abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'pointer) in
    let _2 = (peek_val parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr((
# 376 "src/cparser.mly"
                                               ) : 'abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'abstract_declarator) in
    Obj.repr((
# 380 "src/cparser.mly"
                                          ) : 'direct_abstract_declarator))
; (fun parser_env ->
    Obj.repr((
# 381 "src/cparser.mly"
                            ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 382 "src/cparser.mly"
                                                ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_abstract_declarator) in
    Obj.repr((
# 383 "src/cparser.mly"
                                                       ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_abstract_declarator) in
    let _3 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 384 "src/cparser.mly"
                                                                           ) : 'direct_abstract_declarator))
; (fun parser_env ->
    Obj.repr((
# 385 "src/cparser.mly"
                      ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'parameter_type_list) in
    Obj.repr((
# 386 "src/cparser.mly"
                                          ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_abstract_declarator) in
    Obj.repr((
# 387 "src/cparser.mly"
                                                 ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_abstract_declarator) in
    let _3 = (peek_val parser_env 1 : 'parameter_type_list) in
    Obj.repr((
# 388 "src/cparser.mly"
                                                                     ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 392 "src/cparser.mly"
                                  ) : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'c_initializer_list) in
    Obj.repr((
# 393 "src/cparser.mly"
                                             ) : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'c_initializer_list) in
    Obj.repr((
# 394 "src/cparser.mly"
                                                   ) : 'c_initializer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 398 "src/cparser.mly"
                          ) : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'c_initializer_list) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 399 "src/cparser.mly"
                                                   ) : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'labeled_statement) in
    Obj.repr((
# 403 "src/cparser.mly"
                              ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 404 "src/cparser.mly"
                               ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'expression_statement) in
    Obj.repr((
# 405 "src/cparser.mly"
                                 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'selection_statement) in
    Obj.repr((
# 406 "src/cparser.mly"
                                ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'iteration_statement) in
    Obj.repr((
# 407 "src/cparser.mly"
                                ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'jump_statement) in
    Obj.repr((
# 408 "src/cparser.mly"
                           ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 412 "src/cparser.mly"
                                       ) : 'labeled_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'constant_expression) in
    let _4 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 413 "src/cparser.mly"
                                                     ) : 'labeled_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 414 "src/cparser.mly"
                                    ) : 'labeled_statement))
; (fun parser_env ->
    Obj.repr((
# 418 "src/cparser.mly"
                          [], [] ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'statement_list) in
    Obj.repr((
# 419 "src/cparser.mly"
                                         [], _2 ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'declaration_list) in
    Obj.repr((
# 420 "src/cparser.mly"
                                           _2, [] ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'declaration_list) in
    let _3 = (peek_val parser_env 1 : 'statement_list) in
    Obj.repr((
# 421 "src/cparser.mly"
                                                          _2, _3 ) : 'compound_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'annot) in
    let _2 = (peek_val parser_env 1 : 'compound_statement) in
    let _3 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 426 "src/cparser.mly"
                                           (loc (), _1, _2, _3) ) : 'annot_compound_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 430 "src/cparser.mly"
                        _1 ) : 'declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_list) in
    let _2 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 431 "src/cparser.mly"
                                         _1 @ _2 ) : 'declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 435 "src/cparser.mly"
                      [_1] ) : 'statement_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'statement_list) in
    let _2 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 436 "src/cparser.mly"
                                     _1 @ [_2] ) : 'statement_list))
; (fun parser_env ->
    Obj.repr((
# 440 "src/cparser.mly"
                      ) : 'expression_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 441 "src/cparser.mly"
                                 ) : 'expression_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 445 "src/cparser.mly"
                                              ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : 'expression) in
    let _5 = (peek_val parser_env 2 : 'statement) in
    let _7 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 446 "src/cparser.mly"
                                                             ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 447 "src/cparser.mly"
                                                  ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 451 "src/cparser.mly"
                                                 ) : 'iteration_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 5 : 'statement) in
    let _5 = (peek_val parser_env 2 : 'expression) in
    Obj.repr((
# 452 "src/cparser.mly"
                                                              ) : 'iteration_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : 'expression_statement) in
    let _4 = (peek_val parser_env 2 : 'expression_statement) in
    let _6 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 453 "src/cparser.mly"
                                                                              ) : 'iteration_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : 'expression_statement) in
    let _4 = (peek_val parser_env 3 : 'expression_statement) in
    let _5 = (peek_val parser_env 2 : 'expression) in
    let _7 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 454 "src/cparser.mly"
                                                                                         ) : 'iteration_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : string) in
    Obj.repr((
# 458 "src/cparser.mly"
                                      ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 459 "src/cparser.mly"
                               ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 460 "src/cparser.mly"
                            ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 461 "src/cparser.mly"
                             ) : 'jump_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 462 "src/cparser.mly"
                                        ) : 'jump_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'external_declaration) in
    Obj.repr((
# 466 "src/cparser.mly"
                                 _1 ) : 'translation_unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'translation_unit) in
    let _2 = (peek_val parser_env 0 : 'external_declaration) in
    Obj.repr((
# 467 "src/cparser.mly"
                                                  _1 @ _2 ) : 'translation_unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'function_definition) in
    Obj.repr((
# 471 "src/cparser.mly"
                                uns() ) : 'external_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 472 "src/cparser.mly"
                        _1 ) : 'external_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 1 : 'declaration_list) in
    let _4 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 477 "src/cparser.mly"
              ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 1 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 478 "src/cparser.mly"
                                                                 ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _2 = (peek_val parser_env 1 : 'declaration_list) in
    let _3 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 479 "src/cparser.mly"
                                                           ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declarator) in
    let _2 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 480 "src/cparser.mly"
                                          ) : 'function_definition))
(* Entry file *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error;
    names_const=yynames_const;
    names_block=yynames_block }
let file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Cast.file)
